#include<bits/stdc++.h>
#define ll long long
#define ull unsigned long long
#define pb push_back
#define mk make_pair
#define v_sort(x) sort(x.begin(),x.end())
#define v_gsort(x) sort(x.begin(),x.end(),greater<ll>())
#define v_find(x,num) find(x.begin(),x.end(),num)
#define PI 3.14159265
#define MOD 1000000007
#define MOD1 998244353

using namespace std;

int bl[4];

void get(int idx,int &k,int &x){
  x=min(bl[idx],k);
  k-=x;
  bl[idx]-=x;
}

void Solve(){
  int n;
  cin>>n>>bl[0]>>bl[1]>>bl[2]>>bl[3];
  vector<pair<int,pair<int,int>>>a(n);
  vector<vector<int>>ans(n,vector<int>(4,0));
  for(int i=0;i<n;i++){
    string c;
    int k;
    cin>>c>>k;
    int idx=-1;
    int x;
    if(c=="O") idx=0;
    else if(c=="A") idx=1;
    else if(c=="B") idx=2;
    else if(c=="AB") idx=3;
    get(idx,k,x);
    ans[i][idx]+=x;
    a[i]={idx,{k,i}};
  }
  int ok=1;
  for(int i=0;i<n;i++){
    int idx=a[i].first,x;
    int k=a[i].second.first;
    if(idx==0){
      if(bl[0]==0 && k>0) ok=0;
    }
    if(idx==1){
      get(0,k,x);
      ans[i][0]+=x;
      if(k>0) ok=0;
    }
    if(idx==2){
      get(0,k,x);
      ans[i][0]+=x;
      if(k>0) ok=0;
    }
    if(idx==3){
      get(0,k,x);
      ans[i][0]+=x;
      get(1,k,x);
      ans[i][1]+=x;
      get(2,k,x);
      ans[i][2]+=x;
      if(k>0) ok=0;
    }
  }
  if(!ok) cout<<"nemoguce\n";
  else{
    cout<<"moguce\n";
    for(int i=0;i<n;i++){
      for(int j=0;j<4;j++) cout<<ans[i][j]<<' ';
      cout<<'\n';
    }
  }
}

int main(){
  ios::sync_with_stdio(false);
  cin.tie(NULL);
  int t=1;
//  freopen("input.txt","r",stdin);
//  freopen("output.txt","w",stdout);
//  cin>>t;
  while(t--){
    Solve();
  }
  return 0;
}